#include<iostream>
using namespace std;
int met[1000];
int main()
{
    int t;
    cin>>t;
    while(t--)
    {
        for(int i=0; i<1000; i++)
        {
            met[i]=0;
        }
        int a, v, n;
        cin>>a>>v>>n;
        int ans=0;
        if(a==v)
        {
            ans++;
        }
        int b=0;
        while(a>0)
        {
            int c=a%10;
            b+=c*c;
            a/=10;
        }
        n--;
        while(!met[b] && n>0)
        {
            n--;
            if(b==v)
            {
                ans++;
            }
            met[b]=1;
            int d=0;
            while(b>0)
            {
                int c=b%10;
                d+=c*c;
                b/=10;
            }
            b=d;
        }
        if(n>0)
        {
            int pos=100000000;
            int cnt=0;
            while(met[b]==1)
            {
                if(b==v)
                {
                    pos=cnt;
                }
                cnt++;
                met[b]=2;
                int d=0;
                while(b>0)
                {
                    int c=b%10;
                    d+=c*c;
                    b/=10;
                }
                b=d;
            }
            if(pos<=cnt){
                ans+=n/cnt;
            }
            if(n%cnt>pos)
            {
                ans++;
            }
        }
        cout<<ans<<endl;
        //cout<<b<<endl;
    }
    return 0;
}
